% Hyphonation for text and url
\usepackage[english]{babel}
\usepackage[hyphens]{url}

% Accept é ë etc
\usepackage[utf8]{inputenc}
\usepackage[T1]{fontenc}
% Thanks, Laura Baakman

% More fonts and symbols
\usepackage{textcomp}
\usepackage{amsfonts}

% Allow for more symbols etc
\usepackage{verbatim}
\usepackage{marvosym}
\usepackage{amsmath}

% Math... and stuff
\usepackage{mathtools}

% Colors etc
\usepackage{color}
\usepackage[usenames,dvipsnames]{xcolor}
\definecolor{light-gray}{gray}{0.95}

% Listings and other mark up
\usepackage{enumerate}
\usepackage{listings}
\usepackage{appendix}
\usepackage{hyperref}
\usepackage{longtable}
\usepackage{ragged2e}

% Define the style of lstlisting
\lstset{
    language=Java, %Java is closest to APEX     % choose the language of the code
    breaklines=true,                            % sets automatic line breaking
    breakatwhitespace=false,                    % sets if automatic breaks should only happen at whitespace
    basicstyle=\ttfamily,                       % the size of the fonts that are used for the code
    numbers=left,                               % where to put the line-numbers
    numberstyle=\footnotesize,                  % the size of the fonts that are used for the line-numbers
    stepnumber=1,                               % the step between two line-numbers. If it's 1 each line will be numbered
    numbersep=5pt,                              % how far the line-numbers are from the code
    numberfirstline=false,                      % if the first line should also be numbered
    backgroundcolor=\color{light-gray},         % choose the background color. You must add \usepackage{color}
    showspaces=false,                           % show spaces adding particular underscores
    showstringspaces=false,                     % underline spaces within strings
    showtabs=false,                             % show tabs within strings adding particular underscores
    tabsize=4,                                  % sets default tabsize to 4 spaces
    captionpos=t,                               % sets the caption-position to top
    escapeinside={\%*}{*)},                     % if you want to add a comment within your code
}
% Thanks to Dirk Zittersteyn

\definecolor{lightgray}{rgb}{.9,.9,.9}
\definecolor{darkgray}{rgb}{.4,.4,.4}
\definecolor{purple}{rgb}{0.65, 0.12, 0.82}
\lstdefinelanguage{JavaScript}{
  keywords={break, case, catch, continue, debugger, default, delete, do, else, false, finally, for, function, if, in, instanceof, new, null, return, switch, this, throw, true, try, typeof, var, void, while, with},
  morecomment=[l]{//},
  morecomment=[s]{/*}{*/},
  morestring=[b]',
  morestring=[b]",
  ndkeywords={class, export, boolean, throw, implements, import, this},
  keywordstyle=\color{blue}\bfseries,
  ndkeywordstyle=\color{darkgray}\bfseries,
  identifierstyle=\color{black},
  commentstyle=\color{purple}\ttfamily,
  stringstyle=\color{red}\ttfamily,
  sensitive=true
}% Listing language support for Javascript

%listing language json
\newcommand\JSONnumbervaluestyle{\color{blue}}
\newcommand\JSONstringvaluestyle{\color{red}}

% switch used as state variable
\newif\ifcolonfoundonthisline

\makeatletter

\lstdefinelanguage{json} {
  showstringspaces    = false,
  keywords            = {false,true},
  alsoletter          = 0123456789.,
  morestring          = [s]{"}{"},
  stringstyle         = \ifcolonfoundonthisline\JSONstringvaluestyle\fi,
  MoreSelectCharTable =%
    \lst@DefSaveDef{`:}\colon@json{\processColon@json},
  basicstyle          = \ttfamily,
  keywordstyle        = \ttfamily\bfseries,
}

% flip the switch if a colon is found in Pmode
\newcommand\processColon@json{%
  \colon@json%
  \ifnum\lst@mode=\lst@Pmode%
    \global\colonfoundonthislinetrue%
  \fi
}

\lst@AddToHook{Output}{%
  \ifcolonfoundonthisline%
    \ifnum\lst@mode=\lst@Pmode%
      \def\lst@thestyle{\JSONnumbervaluestyle}%
    \fi
  \fi
  %override by keyword style if a keyword is detected!
  \lsthk@DetectKeywords% 
}

% reset the switch at the end of line
\lst@AddToHook{EOL}%
  {\global\colonfoundonthislinefalse}

\makeatother
% Listing support for JSON


% Graphics like pictures
\usepackage{graphicx}
\usepackage{graphics}
\usepackage{caption}
\usepackage{subcaption}
\usepackage{wrapfig}
\usepackage{epsfig}
\usepackage{epstopdf}

%idunno
\usepackage{float}
\usepackage[top=1in, bottom=1in, left=1in, right=1in]{geometry}
%\captionsetup[figure]{justification=justified,singlelinecheck=false}
%\captionsetup[table]{justification=justified,singlelinecheck=false}
% unused ^

\usepackage{multirow}
\usepackage{csquotes}

\iffalse
\usepackage[
    backend=biber,
    style=numeric,
    sorting=none
]{biblatex}
\addbibresource{a_sources.bib}
\fi
 
\usepackage{titlesec}
\titleformat{\chapter}[display]
{\normalfont\huge\bfseries}{\chaptertitlename\ \thechapter}{20pt}{\Huge}   
\titlespacing*{\chapter}{0pt}{-10pt}{20pt}

\usepackage{titling}
\usepackage{lipsum}

\usepackage{pdfpages}
\usepackage[hang, bottom]{footmisc}%flushmargin removes the margin between number and text

\usepackage{longtable}
\usepackage{parskip}

\setcounter{secnumdepth}{3} %number subsubsec's

\usepackage{gensymb} %\degree symbol